VERSION 5.00
Begin VB.Form frmMain 
   BorderStyle     =   5  'Sizable ToolWindow
   Caption         =   "Toolbox"
   ClientHeight    =   3225
   ClientLeft      =   60
   ClientTop       =   300
   ClientWidth     =   3735
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3225
   ScaleWidth      =   3735
   ShowInTaskbar   =   0   'False
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton cmd 
      BackColor       =   &H000000FF&
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   14.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   615
      Index           =   0
      Left            =   120
      Style           =   1  'Graphical
      TabIndex        =   0
      Top             =   300
      Width           =   615
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim WithEvents sc As SubClasser
Attribute sc.VB_VarHelpID = -1

'---- Global variables
Dim szButton As SIZE
Dim szBorder As SIZE
Const NBBUTTONS = 10
'---- System constants for border
Dim cxFrame As Integer
Dim cyFrame As Integer
Dim cySmallCaption As Integer

'---- Initializations
Private Sub Form_Load()
    ScaleMode = vbTwips
    ' Create buttons
    szButton.cx = cmd(0).Width
    szButton.cy = cmd(0).Height
    Dim i
    For i = 0 To NBBUTTONS - 1
        If i <> 0 Then Load cmd(i)
        cmd(i).Caption = i + 1
        cmd(i).BackColor = QBColor(i + 1)
        cmd(i).Move 0, i * szButton.cy
        cmd(i).Visible = True
    Next
    
    ' Adjust the window size (buttons are initialy vertical)
    Dim sz As SIZE
    sz = ComputeFormDimensions(Me.hwnd, szButton.cx, _
            szButton.cy * NBBUTTONS)
    Me.Width = sz.cx
    Me.Height = sz.cy
    
    ' Compute border dimensions
    szBorder = ComputeFormDimensions(Me.hwnd, 0, 0)
    
    ' Get border constants
    cxFrame = GetSystemMetrics(SM_CXFRAME)
    cyFrame = GetSystemMetrics(SM_CYFRAME)
    cySmallCaption = GetSystemMetrics(SM_CYSMCAPTION)

    ' Subclass window
    Set sc = New SubClasser
    sc.SubClass hwnd
End Sub

'---- End
Private Sub Form_Unload(Cancel As Integer)
    ' Remove subclassing
    sc.ReClass
End Sub

'---- Message processing
Private Sub sc_WindowMessage(ByVal hwnd As Long, ByVal uMsg As Long,_
        ByVal wParam As Long, ByVal lParam As Long, Result As Long,_
        CallDefault As Boolean)
    ' Process the message
    Select Case uMsg
        ' Sizing
        Case WM_SIZING
            ' lParam points to rectangle
            Dim rc As RECT
            ' Get it
            MemCopy rc, ByVal lParam, Len(rc)
            ' Convert to Twips
            rcPixelsToTwips rc
            
            ' Call function to process
            Sizing hwnd, wParam, rc
            
            ' Back to pixels
            rcTwipsToPixels rc
            ' Put it back
            MemCopy ByVal lParam, rc, Len(rc)
            
            ' Result
            Result = True
            CallDefault = False
            
        ' Hittest
        Case WM_NCHITTEST
            Result = Hittest(hwnd, wParam, lParam)
            CallDefault = False

        ' Other messages
        Case Else
            CallDefault = True
    End Select
End Sub

'---- Process WM_SIZING message
Private Sub Sizing(hwnd As Long, wParam As Long, rc As RECT)
    ' Compute new dimensions
    ' Client area dimensions
    Dim sz As SIZE
    ' Number of buttons
    Dim nbH As Long, nbV As Long
    
    If wParam = WMSZ_LEFT Or wParam = WMSZ_RIGHT Then
        ' Modify horizontal dimension
        sz.cx = rc.Right - rc.Left - szBorder.cx
        
        ' Number of buttons horizontaly
        nbH = CLng(sz.cx / szButton.cx)
        ' Check min/max
        If nbH > NBBUTTONS Then
            nbH = NBBUTTONS
        ElseIf nbH < 1 Then
            nbH = 1
        End If
        
        ' New width
        sz.cx = nbH * szButton.cx
        
        ' Compute height
        nbV = Int(NBBUTTONS / nbH)
        If NBBUTTONS Mod nbH <> 0 Then nbV = nbV + 1
        sz.cy = nbV * szButton.cy
    
    Else
        ' Modify vertical dimension
        sz.cy = rc.Bottom - rc.Top - szBorder.cy
        
        ' Number of buttons verticaly
        nbV = CLng(sz.cy / szButton.cy)
        ' Check min/max
        If nbV > NBBUTTONS / 2 Then
            nbV = NBBUTTONS
        ElseIf nbV < 1 Then
            nbV = 1
        End If
        
        ' New height
        sz.cy = nbV * szButton.cy
        
        ' Compute width
        nbH = Int(NBBUTTONS / nbV)
        If NBBUTTONS Mod nbV <> 0 Then nbH = nbH + 1
        sz.cx = nbH * szButton.cx
    End If
    
    ' Add borders
    sz = ComputeFormDimensions(hwnd, sz.cx, sz.cy)
    
    ' New rectangle
    Select Case wParam
        Case WMSZ_LEFT, WMSZ_BOTTOMLEFT, WMSZ_TOPLEFT
            rc.Left = rc.Right - sz.cx
            rc.Bottom = rc.Top + sz.cy
        Case WMSZ_RIGHT, WMSZ_BOTTOMRIGHT, WMSZ_TOPRIGHT
            rc.Right = rc.Left + sz.cx
            rc.Bottom = rc.Top + sz.cy
        Case WMSZ_TOP
            rc.Right = rc.Left + sz.cx
            rc.Top = rc.Bottom - sz.cy
        Case WMSZ_BOTTOM
            rc.Right = rc.Left + sz.cx
            rc.Bottom = rc.Top + sz.cy
    End Select
    
    ' Move buttons
    Dim x As Long: x = 0
    Dim y As Long: y = 0
    Dim i
    For i = 0 To NBBUTTONS - 1
        cmd(i).Move x, y
        If (i + 1) Mod nbH = 0 Then
            x = 0
            y = y + szButton.cy
        Else
            x = x + szButton.cx
        End If
    Next
End Sub

'---- Process Hittest
Private Function Hittest(ByVal hwnd As Long, ByVal wParam As Long,_
        ByVal lParam As Long) As Long
    ' Call default procedure to know where we are
    Dim ht As Long
    ht = sc.CallPrevWindowProc(hwnd, WM_NCHITTEST, wParam, lParam)
    
    ' Window rectangle
    Dim rc As RECT
    GetWindowRect hwnd, rc
    ' Hittest point
    Dim x As Integer, y As Integer
    x = LOWORD(lParam)
    y = HIWORD(lParam)
    
    ' Replace corners
    Select Case ht
        Case HTBOTTOMLEFT
            ht = IIf(rc.Bottom - y < cyFrame, HTBOTTOM, HTLEFT)
        Case HTBOTTOMRIGHT
            ht = IIf(rc.Bottom - y < cyFrame, HTBOTTOM, HTRIGHT)
        Case HTTOPLEFT
            ht = IIf(y - rc.Top < cyFrame, HTTOP, HTLEFT)
        Case HTTOPRIGHT
            ht = IIf(y - rc.Top < cyFrame, HTTOP, HTRIGHT)
    End Select
    
    ' Return value
    Hittest = ht
End Function
